#2 minutes 16 seconds#
Name:          libtorrent-rasterbar
License:       BSD
Group:         System Environment/Libraries
Version:       1.2.14
Release:       2%{?dist}
Summary:       C++ bittorrent library by Rasterbar Software
URL:           http://www.rasterbar.com/products/libtorrent/
%undefine _disable_source_fetch
Source0:        https://github.com/arvidn/libtorrent/releases/download/v%{version}/libtorrent-rasterbar-%{version}.tar.gz       
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%define debug_package %nil

#BuildRequires:  epel
BuildRequires:  python3-devel, glibc-devel, make
BuildRequires:  ninja-build 

%if 0%{?rhel} ==7
BuildRequires:  boost171-b2, boost171
BuildRequires:  kloxo-openssl
BuildRequires:  cmake3
BuildRequires:  devtoolset-9-gcc-c++
%define cmakeinstall cmake3 -DOPENSSL_ROOT_DIR=/usr/local/openssl -Dboost-python-module-name=python36 -DCMAKE_CXX_COMPILER=/opt/rh/devtoolset-9/root/bin/g++ -DCMAKE_C_COMPILER=/opt/rh/devtoolset-9/root/bin/gcc
%endif

%if 0%{?rhel} ==8
BuildRequires:  boost, boost-devel,boost-python3,boost-python3-devel
BuildRequires:  openssl-devel
BuildRequires:  cmake
BuildRequires:  gcc, gcc-c++
%define cmakeinstall cmake -Dboost-python-module-name=python3 -Dbuild_tests=1
%endif

%description
rb_libtorrent is a C++ library that aims to be a good alternative to all
the other BitTorrent implementations around. It is a library and not a full
featured client, although it comes with a few working example clients.
Its main goals are to be very efficient (in terms of CPU and memory usage) as
well as being very easy to use both as a user and developer.

#package devel
%package devel
Summary: Development files for rb_libtorrent
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
The rb_libtorrent-devel package contains libraries and header files for
developing applications that use rb_libtorrent.
The various source and header files included in this package are licensed
under the revised BSD, zlib/libpng, and Boost Public licenses. See the various
COPYING files in the included documentation for the full text of these
licenses, as well as the comments blocks in the source code for which license
a given source or header file is released under.
#end-devel

%prep
%setup -q


%build
mkdir build
pushd build
#-DBOOST_LIBRARYDIR=/usr/local/boost175/lib/ 
#-DBOOST_ROOT=/usr/local/boost175/ 
#-DPYTHON_EXECUTABLE=/usr/bin/python3 
#-DPYTHON_INCLUDE_DIR=/usr/include/python3.6m/ 
#-DPYTHON_LIBRARY=/usr/lib64/python3.6#-DCMAKE_BUILD_WITH_INSTALL_RPATH=ON
#-Dbuild_tests=1 Dbuild_tools=1
%{cmakeinstall} \
-Dpython-bindings=1 \
-DCMAKE_INSTALL_PREFIX:PATH=/usr \
-DCMAKE_CXX_STANDARD=17 -DCMAKE_BUILD_TYPE=Release -G Ninja ..
ninja %{?_smp_mflags}

#export CC=/usr/local/gcc9/bin/gcc
#export CXX=/usr/local/gcc9/bin/g++
#--with-openssl=/usr/local/openssl \
#export PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/local/openssl/lib/pkgconfig:/usr/local/zlib/lib64/pkgconfig
#./configure --with-cxx-standard=17 \
#   --with-boost=/usr/local/boost171 \
#   --with-libiconv --with-boost-python \
#   --enable-python-binding \
#   --enable-shared --enable-tests \
#   --prefix=%{_prefix} --libdir=%{_libdir}    
    
#%{__make} %{?_smp_mflags}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
DESTDIR=$RPM_BUILD_ROOT ninja -C build install

%check
%if 0%{?rhel} ==8
ninja -v -d explain -C build test %{?_smp_mflags} || exit 0
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
/usr/lib64/libtorrent-rasterbar.so.%{version}
/usr/lib64/libtorrent-rasterbar.so.10

%files devel
#/usr/include/libtorrent/ConvertUTF.h
/usr/include/libtorrent/add_torrent_params.hpp
/usr/include/libtorrent/address.hpp
/usr/include/libtorrent/alert.hpp
/usr/include/libtorrent/alert_manager.hpp
/usr/include/libtorrent/alert_types.hpp
/usr/include/libtorrent/announce_entry.hpp
/usr/include/libtorrent/assert.hpp
/usr/include/libtorrent/aux_/aligned_storage.hpp
/usr/include/libtorrent/aux_/aligned_union.hpp
/usr/include/libtorrent/aux_/alloca.hpp
/usr/include/libtorrent/aux_/allocating_handler.hpp
/usr/include/libtorrent/aux_/array.hpp
/usr/include/libtorrent/aux_/bind_to_device.hpp
/usr/include/libtorrent/aux_/block_cache_reference.hpp
/usr/include/libtorrent/aux_/byteswap.hpp
/usr/include/libtorrent/aux_/container_wrapper.hpp
/usr/include/libtorrent/aux_/cppint_import_export.hpp
/usr/include/libtorrent/aux_/cpuid.hpp
/usr/include/libtorrent/aux_/deferred_handler.hpp
/usr/include/libtorrent/aux_/deprecated.hpp
/usr/include/libtorrent/aux_/deque.hpp
/usr/include/libtorrent/aux_/dev_random.hpp
/usr/include/libtorrent/aux_/disable_warnings_pop.hpp
/usr/include/libtorrent/aux_/disable_warnings_push.hpp
/usr/include/libtorrent/aux_/disk_job_fence.hpp
/usr/include/libtorrent/aux_/escape_string.hpp
/usr/include/libtorrent/aux_/export.hpp
/usr/include/libtorrent/aux_/ffs.hpp
/usr/include/libtorrent/aux_/file_progress.hpp
/usr/include/libtorrent/aux_/generate_peer_id.hpp
/usr/include/libtorrent/aux_/has_block.hpp
/usr/include/libtorrent/aux_/instantiate_connection.hpp
/usr/include/libtorrent/aux_/io.hpp
/usr/include/libtorrent/aux_/ip_notifier.hpp
/usr/include/libtorrent/aux_/keepalive.hpp
/usr/include/libtorrent/aux_/listen_socket_handle.hpp
/usr/include/libtorrent/aux_/lsd.hpp
/usr/include/libtorrent/aux_/merkle.hpp
/usr/include/libtorrent/aux_/noexcept_movable.hpp
/usr/include/libtorrent/aux_/numeric_cast.hpp
/usr/include/libtorrent/aux_/openssl.hpp
/usr/include/libtorrent/aux_/path.hpp
/usr/include/libtorrent/aux_/portmap.hpp
/usr/include/libtorrent/aux_/proxy_settings.hpp
/usr/include/libtorrent/aux_/range.hpp
/usr/include/libtorrent/aux_/route.h
/usr/include/libtorrent/aux_/scope_end.hpp
/usr/include/libtorrent/aux_/session_call.hpp
/usr/include/libtorrent/aux_/session_impl.hpp
/usr/include/libtorrent/aux_/session_interface.hpp
/usr/include/libtorrent/aux_/session_settings.hpp
/usr/include/libtorrent/aux_/session_udp_sockets.hpp
/usr/include/libtorrent/aux_/set_socket_buffer.hpp
/usr/include/libtorrent/aux_/socket_type.hpp
/usr/include/libtorrent/aux_/storage_piece_set.hpp
/usr/include/libtorrent/aux_/storage_utils.hpp
/usr/include/libtorrent/aux_/string_ptr.hpp
/usr/include/libtorrent/aux_/suggest_piece.hpp
/usr/include/libtorrent/aux_/throw.hpp
/usr/include/libtorrent/aux_/time.hpp
/usr/include/libtorrent/aux_/torrent_impl.hpp
/usr/include/libtorrent/aux_/unique_ptr.hpp
/usr/include/libtorrent/aux_/vector.hpp
/usr/include/libtorrent/aux_/win_crypto_provider.hpp
/usr/include/libtorrent/aux_/win_util.hpp
/usr/include/libtorrent/aux_/windows.hpp
/usr/include/libtorrent/bandwidth_limit.hpp
/usr/include/libtorrent/bandwidth_manager.hpp
/usr/include/libtorrent/bandwidth_queue_entry.hpp
/usr/include/libtorrent/bandwidth_socket.hpp
/usr/include/libtorrent/bdecode.hpp
/usr/include/libtorrent/bencode.hpp
/usr/include/libtorrent/bitfield.hpp
/usr/include/libtorrent/block_cache.hpp
/usr/include/libtorrent/bloom_filter.hpp
/usr/include/libtorrent/broadcast_socket.hpp
/usr/include/libtorrent/bt_peer_connection.hpp
/usr/include/libtorrent/buffer.hpp
/usr/include/libtorrent/chained_buffer.hpp
/usr/include/libtorrent/choker.hpp
/usr/include/libtorrent/close_reason.hpp
/usr/include/libtorrent/config.hpp
/usr/include/libtorrent/copy_ptr.hpp
/usr/include/libtorrent/crc32c.hpp
/usr/include/libtorrent/create_torrent.hpp
/usr/include/libtorrent/deadline_timer.hpp
/usr/include/libtorrent/debug.hpp
/usr/include/libtorrent/disk_buffer_holder.hpp
/usr/include/libtorrent/disk_buffer_pool.hpp
/usr/include/libtorrent/disk_interface.hpp
/usr/include/libtorrent/disk_io_job.hpp
/usr/include/libtorrent/disk_io_thread.hpp
/usr/include/libtorrent/disk_io_thread_pool.hpp
/usr/include/libtorrent/disk_job_pool.hpp
/usr/include/libtorrent/disk_observer.hpp
/usr/include/libtorrent/download_priority.hpp
/usr/include/libtorrent/ed25519.hpp
/usr/include/libtorrent/entry.hpp
/usr/include/libtorrent/enum_net.hpp
/usr/include/libtorrent/error.hpp
/usr/include/libtorrent/error_code.hpp
/usr/include/libtorrent/extensions.hpp
/usr/include/libtorrent/extensions/smart_ban.hpp
/usr/include/libtorrent/extensions/ut_metadata.hpp
/usr/include/libtorrent/extensions/ut_pex.hpp
/usr/include/libtorrent/file.hpp
/usr/include/libtorrent/file_pool.hpp
/usr/include/libtorrent/file_storage.hpp
/usr/include/libtorrent/fingerprint.hpp
/usr/include/libtorrent/flags.hpp
/usr/include/libtorrent/fwd.hpp
/usr/include/libtorrent/gzip.hpp
/usr/include/libtorrent/hasher.hpp
/usr/include/libtorrent/hasher512.hpp
/usr/include/libtorrent/heterogeneous_queue.hpp
/usr/include/libtorrent/hex.hpp
/usr/include/libtorrent/http_connection.hpp
/usr/include/libtorrent/http_parser.hpp
/usr/include/libtorrent/http_seed_connection.hpp
/usr/include/libtorrent/http_stream.hpp
/usr/include/libtorrent/http_tracker_connection.hpp
/usr/include/libtorrent/i2p_stream.hpp
/usr/include/libtorrent/identify_client.hpp
/usr/include/libtorrent/index_range.hpp
/usr/include/libtorrent/invariant_check.hpp
/usr/include/libtorrent/io.hpp
/usr/include/libtorrent/io_service.hpp
/usr/include/libtorrent/io_service_fwd.hpp
/usr/include/libtorrent/ip_filter.hpp
/usr/include/libtorrent/ip_voter.hpp
/usr/include/libtorrent/kademlia/announce_flags.hpp
/usr/include/libtorrent/kademlia/dht_observer.hpp
/usr/include/libtorrent/kademlia/dht_settings.hpp
/usr/include/libtorrent/kademlia/dht_state.hpp
/usr/include/libtorrent/kademlia/dht_storage.hpp
/usr/include/libtorrent/kademlia/dht_tracker.hpp
/usr/include/libtorrent/kademlia/direct_request.hpp
/usr/include/libtorrent/kademlia/dos_blocker.hpp
/usr/include/libtorrent/kademlia/ed25519.hpp
/usr/include/libtorrent/kademlia/find_data.hpp
/usr/include/libtorrent/kademlia/get_item.hpp
/usr/include/libtorrent/kademlia/get_peers.hpp
/usr/include/libtorrent/kademlia/io.hpp
/usr/include/libtorrent/kademlia/item.hpp
/usr/include/libtorrent/kademlia/msg.hpp
/usr/include/libtorrent/kademlia/node.hpp
/usr/include/libtorrent/kademlia/node_entry.hpp
/usr/include/libtorrent/kademlia/node_id.hpp
/usr/include/libtorrent/kademlia/observer.hpp
/usr/include/libtorrent/kademlia/put_data.hpp
/usr/include/libtorrent/kademlia/refresh.hpp
/usr/include/libtorrent/kademlia/routing_table.hpp
/usr/include/libtorrent/kademlia/rpc_manager.hpp
/usr/include/libtorrent/kademlia/sample_infohashes.hpp
/usr/include/libtorrent/kademlia/traversal_algorithm.hpp
/usr/include/libtorrent/kademlia/types.hpp
/usr/include/libtorrent/lazy_entry.hpp
/usr/include/libtorrent/link.hpp
/usr/include/libtorrent/linked_list.hpp
/usr/include/libtorrent/lsd.hpp
/usr/include/libtorrent/magnet_uri.hpp
/usr/include/libtorrent/natpmp.hpp
/usr/include/libtorrent/netlink.hpp
/usr/include/libtorrent/operations.hpp
/usr/include/libtorrent/optional.hpp
/usr/include/libtorrent/packet_buffer.hpp
/usr/include/libtorrent/packet_pool.hpp
/usr/include/libtorrent/parse_url.hpp
/usr/include/libtorrent/part_file.hpp
/usr/include/libtorrent/pe_crypto.hpp
/usr/include/libtorrent/peer.hpp
/usr/include/libtorrent/peer_class.hpp
/usr/include/libtorrent/peer_class_set.hpp
/usr/include/libtorrent/peer_class_type_filter.hpp
/usr/include/libtorrent/peer_connection.hpp
/usr/include/libtorrent/peer_connection_handle.hpp
/usr/include/libtorrent/peer_connection_interface.hpp
/usr/include/libtorrent/peer_id.hpp
/usr/include/libtorrent/peer_info.hpp
/usr/include/libtorrent/peer_list.hpp
/usr/include/libtorrent/peer_request.hpp
/usr/include/libtorrent/performance_counters.hpp
/usr/include/libtorrent/pex_flags.hpp
/usr/include/libtorrent/piece_block.hpp
/usr/include/libtorrent/piece_block_progress.hpp
/usr/include/libtorrent/piece_picker.hpp
/usr/include/libtorrent/platform_util.hpp
/usr/include/libtorrent/portmap.hpp
/usr/include/libtorrent/proxy_base.hpp
/usr/include/libtorrent/puff.hpp
/usr/include/libtorrent/random.hpp
/usr/include/libtorrent/read_resume_data.hpp
/usr/include/libtorrent/receive_buffer.hpp
/usr/include/libtorrent/request_blocks.hpp
/usr/include/libtorrent/resolve_links.hpp
/usr/include/libtorrent/resolver.hpp
/usr/include/libtorrent/resolver_interface.hpp
/usr/include/libtorrent/session.hpp
/usr/include/libtorrent/session_handle.hpp
/usr/include/libtorrent/session_settings.hpp
/usr/include/libtorrent/session_stats.hpp
/usr/include/libtorrent/session_status.hpp
/usr/include/libtorrent/session_types.hpp
/usr/include/libtorrent/settings_pack.hpp
/usr/include/libtorrent/sha1.hpp
/usr/include/libtorrent/sha1_hash.hpp
/usr/include/libtorrent/sha512.hpp
/usr/include/libtorrent/sliding_average.hpp
/usr/include/libtorrent/socket.hpp
/usr/include/libtorrent/socket_io.hpp
/usr/include/libtorrent/socks5_stream.hpp
/usr/include/libtorrent/span.hpp
/usr/include/libtorrent/ssl_stream.hpp
/usr/include/libtorrent/stack_allocator.hpp
/usr/include/libtorrent/stat.hpp
/usr/include/libtorrent/stat_cache.hpp
/usr/include/libtorrent/storage.hpp
/usr/include/libtorrent/storage_defs.hpp
/usr/include/libtorrent/string_util.hpp
/usr/include/libtorrent/string_view.hpp
/usr/include/libtorrent/tailqueue.hpp
/usr/include/libtorrent/time.hpp
/usr/include/libtorrent/timestamp_history.hpp
/usr/include/libtorrent/torrent.hpp
/usr/include/libtorrent/torrent_flags.hpp
/usr/include/libtorrent/torrent_handle.hpp
/usr/include/libtorrent/torrent_info.hpp
/usr/include/libtorrent/torrent_peer.hpp
/usr/include/libtorrent/torrent_peer_allocator.hpp
/usr/include/libtorrent/torrent_status.hpp
/usr/include/libtorrent/tracker_manager.hpp
/usr/include/libtorrent/udp_socket.hpp
/usr/include/libtorrent/udp_tracker_connection.hpp
/usr/include/libtorrent/union_endpoint.hpp
/usr/include/libtorrent/units.hpp
/usr/include/libtorrent/upnp.hpp
/usr/include/libtorrent/utf8.hpp
/usr/include/libtorrent/utp_socket_manager.hpp
/usr/include/libtorrent/utp_stream.hpp
/usr/include/libtorrent/vector_utils.hpp
/usr/include/libtorrent/version.hpp
/usr/include/libtorrent/web_connection_base.hpp
/usr/include/libtorrent/web_peer_connection.hpp
/usr/include/libtorrent/write_resume_data.hpp
/usr/include/libtorrent/xml_parse.hpp
/usr/include/libtorrent/aux_/pool.hpp
/usr/lib64/cmake/LibtorrentRasterbar/LibtorrentRasterbarConfig.cmake
/usr/lib64/cmake/LibtorrentRasterbar/LibtorrentRasterbarConfigVersion.cmake
/usr/lib64/cmake/LibtorrentRasterbar/LibtorrentRasterbarTargets-release.cmake
/usr/lib64/cmake/LibtorrentRasterbar/LibtorrentRasterbarTargets.cmake
/usr/lib64/libtorrent-rasterbar.so
/usr/lib64/pkgconfig/libtorrent-rasterbar.pc
/usr/lib64/python3.6/site-packages/libtorrent.cpython-36m-x86_64-linux-gnu.so
/usr/share/cmake/Modules/FindLibtorrentRasterbar.cmake